/*
 * Header File < axes.h >
 *
 * Draw Axes on View Port for Borland Graphics Interface
 *
 * Copyright (c) 1991-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _AXES_H_
#define _AXES_H_
#include <graphics.h>

/*
 * (̾) drawaxisl  --- ټ
 *        drawaxist  --- ؼ
 *        drawaxisr  --- ټ
 *        drawaxisb  --- ؼ
 * 
 * () drawaxis?( sep, ssep, len, bos )
 *        int sep;      Ĺʬ
 *        int ssep;     ûʬ
 *        int len;      Ĺ
 *        int bos;      ӥ塼ݡȤϤ
 *        
 * () 㤨 setviewport( 30, 30, 130, 130, 0 ) ¹Ԥ塢
 *        drawaxisl( 2, 2, 6, 10 ) Ȥȡ
 *        ӥ塼ݡ(30,30)-(130,130)10ӥåȳ¦ˡټ褵ޤ
 *        ξ硢Ĺ2ʬ䤵줿֤ˡ
 *        û2ʬ䤵줿֤ޤ
 */
#define drawaxisl(s,ss,l,b) drawaxisy(AXIS_LEFT,  s,ss,l,b)
#define drawaxist(s,ss,l,b) drawaxisx(AXIS_TOP,   s,ss,l,b)
#define drawaxisr(s,ss,l,b) drawaxisy(AXIS_RIGHT, s,ss,l,b)
#define drawaxisb(s,ss,l,b) drawaxisx(AXIS_BOTTOM,s,ss,l,b)

/*
 * (̾) drawaxeslb --- ټȲؼ
 *
 * () drawaxeslb( sepx, ssepx, sepy, ssepy, len, bos )
 *        int sepx;     XĹʬ
 *        int ssepx;    Xûʬ
 *        int sepy;     YĹʬ
 *        int ssepy;    Yûʬ
 *        int len;      Ĺ
 *        int bos;      ӥ塼ݡȤϤ
 *        
 * () 㤨 setviewport( 30, 30, 130, 130, 0 ) ¹Ԥ塢
 *        drawaxeslb( 5, 2, 2, 1, 6, 10 ) Ȥȡ
 *        ӥ塼ݡ(30,30)-(130,130)10ӥåȳ¦ˡ
 *        ټȲؼ褵ޤ
 *        ξ硢XĹ5ʬ䤵줿֤ˡ
 *        û2ʬ䤵줿֤ޤ
 *        YĹ2ʬ䤵줿֤ޤ
 *        ûʬ䤷ʤΤʤ
 */
#define drawaxeslb(sx,ssx,sy,ssy,l,b) do{\
        drawaxisl(sy,ssy,l,b);drawaxisb(sx,ssx,l,b);}while(0)

/*
 * (̾) drawaxisix --- ؼ
 *        drawaxisiy --- ټ
 *
 * () drawaxisi?( sep, ssep, len, bos )
 *        int sep;      Ĺʬ
 *        int ssep;     ûʬ
 *        int len;      Ĺ
 *        int bos;      ӥ塼ݡȺɸ
 *        
 * () 㤨 setviewport( 30, 30, 130, 130, 0 ) ¹Ԥ塢
 *        drawaxisix( 2, 0, 6, 50 ) Ȥȡ
 *        ӥ塼ݡ(30,30)-(130,130)100X100Ρ
 *        Y=50ΰ֤ؼ褵ޤ
 *        ξ硢Ĺ2ʬ䤵줿֤졢
 *        ûʤ
 */
#define drawaxisix(s,ss,l,b) drawaxisx(AXIS_INSIDE,s,ss,l,b)
#define drawaxisiy(s,ss,l,b) drawaxisy(AXIS_INSIDE,s,ss,l,b)

/*
 * (̾) drawaxesi --- ؼټ
 *
 * () drawaxesi( sepx, ssepx, sepy, ssepy, len, bosx, bosy )
 *        int sepx;     XĹʬ
 *        int ssepx;    Xûʬ
 *        int sepy;     YĹʬ
 *        int ssepy;    Yûʬ
 *        int len;      Ĺ
 *        int bosx;     Xӥ塼ݡȺɸ
 *        int bosy;     Yӥ塼ݡȺɸ
 *        
 * () 㤨 setviewport( 30, 30, 130, 130, 0 ) ¹Ԥ塢
 *        drawaxesi( 0, 0, 0, 0, 6, 50, 10 ) Ȥȡ
 *        ӥ塼ݡ(30,30)-(130,130)100X100Ρ
 *        Y=50ΰ֤ؼ褵졢X=10ΰ֤ټ褵ޤ
 *        ξ硢Ϥʤ
 */
#define drawaxesi(sx,ssx,sy,ssy,l,bx,by) do{\
        drawaxisix(sx,ssx,l,bx);drawaxisiy(sy,ssy,l,by);}while(0)

enum axis_positions {
  AXIS_LEFT   = 0, /* ټ */
  AXIS_RIGHT  = 1, /* ټ */
  AXIS_TOP    = 0, /* ؼ */
  AXIS_BOTTOM = 1, /* ؼ */
  AXIS_INSIDE = 2, /* XY */
};

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

/*
 * (̾) drawaxisx --- ӥ塼ݡȤأؼ
 *
 * () void drawaxisx( apos, sep, ssep, len, bos )
 *        int apos;     ɸ֥
 *        int sep;      Ĺʬ
 *        int ssep;     ûʬ
 *        int len;      Ĺ
 *        int bos;      ֥פ AXIS_INSIDE ξ硢褹ֺɸ
 *                      ֥פ AXIS_INSIDE ʳϡӥ塼ݡȤϤ
 *
 * () setviewport 줿ӥ塼ݡȤˣؼ衣
 *
 *        apos ˤϰʲΰ֥פΤ줫ꤷޤ
 *
 *        enum axis_positions {
 *          AXIS_TOP    = 0, ؼ
 *          AXIS_BOTTOM = 1, ؼ
 *          AXIS_INSIDE = 2, ؼ
 *        };
 *
 *        bos ˤϰ֥פ AXIS_TOPAXIS_BOTTOM Τ줫ξϡ
 *        ӥ塼ݡȤϤ;͵(ӥåȿ)ꤷޤ
 *        ֥פ AXIS_INSIDE ξ bos ˤϡ
 *        褹ֺɸꤷޤ
 */
void drawaxisx( int apos, int sep, int ssep, int len, int bos );

/*
 * (̾) drawaxisy --- ӥ塼ݡȤأټ
 *
 * () void drawaxisy( apos, sep, ssep, len, bos )
 *        int apos;     ɸ֥
 *        int sep;      Ĺʬ
 *        int ssep;     ûʬ
 *        int len;      Ĺ
 *        int bos;      ֥פ AXIS_INSIDE ξ硢褹ֺɸ
 *                      ֥פ AXIS_INSIDE ʳϡӥ塼ݡȤϤ
 *
 * () setviewport 줿ӥ塼ݡȤˣټ衣
 *
 *        apos ˤϰʲΰ֥פΤ줫ꤷޤ
 *
 *        enum axis_positions {
 *          AXIS_LEFT   = 0, ټ
 *          AXIS_RIGHT  = 1, ټ
 *          AXIS_INSIDE = 2, ټ
 *        };
 *
 *        bos ˤϰ֥פ AXIS_LEFTAXIS_RIGHT Τ줫ξϡ
 *        ӥ塼ݡȤϤ;͵(ӥåȿ)ꤷޤ
 *        ֥פ AXIS_INSIDE ξ bos ˤϡ
 *        褹ֺɸꤷޤ
 */
void drawaxisy( int apos, int sep, int ssep, int len, int bos );

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif
