/*
 * Header File < axes_.h >
 *
 * Draw Axes on Window Port for Borland Graphics Interface
 *
 * Copyright (c) 1991-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _AXES__H_
#define _AXES__H_
#include <graphr2_.h>
#include <axes.h>

/*
 * (̾) drawaxisl_  --- ټ
 *        drawaxist_  --- ؼ
 *        drawaxisr_  --- ټ
 *        drawaxisb_  --- ؼ
 * 
 * () drawaxis?_( sep, ssep, len, bos )
 *        int sep;      Ĺʬ
 *        int ssep;     ûʬ
 *        int len;      Ĺ
 *        int bos;      ӥ塼ݡȤϤ
 *        
 * () 㤨 setviewport_( 30, 30, 130, 130, 0 ) ¹Ԥ塢
 *        setwindow_( -1.0, 10.0, 1.0, -10.0 ) ǲŪʺɸͤꤷ
 *        drawaxisl_( 2, 2, 6, 10 ) Ȥȡ
 *        ӥ塼ݡ(30,30)-(130,130)10ӥåȳ¦ˡټ褵ޤ
 *        ξ硢Ĺ2ʬ䤵줿֤ˡ
 *        û2ʬ䤵줿֤ޤ
 *        줿ɸˤϡŪʺɸͤˤդޤ
 */
#define drawaxisl_(s,ss,l,b) drawaxisy_(AXIS_LEFT,  s,ss,l,b)
#define drawaxist_(s,ss,l,b) drawaxisx_(AXIS_TOP,   s,ss,l,b)
#define drawaxisr_(s,ss,l,b) drawaxisy_(AXIS_RIGHT, s,ss,l,b)
#define drawaxisb_(s,ss,l,b) drawaxisx_(AXIS_BOTTOM,s,ss,l,b)

/*
 * (̾) drawaxeslb_ --- ټȲؼ
 *
 * () drawaxeslb_( sepx, ssepx, sepy, ssepy, len, bos )
 *        int sepx;     XĹʬ
 *        int ssepx;    Xûʬ
 *        int sepy;     YĹʬ
 *        int ssepy;    Yûʬ
 *        int len;      Ĺ
 *        int bos;      ӥ塼ݡȤϤ
 *        
 * () 㤨 setviewport_( 30, 30, 130, 130, 0 ) ¹Ԥ塢
 *        setwindow_( -1.0, 10.0, 1.0, -10.0 ) ǲŪʺɸͤꤷ
 *        drawaxeslb_( 5, 2, 2, 1, 6, 10 ) Ȥȡ
 *        ӥ塼ݡ(30,30)-(130,130)10ӥåȳ¦ˡ
 *        ټȲؼ褵ޤ
 *        ξ硢XĹ5ʬ䤵줿֤ˡ
 *        û2ʬ䤵줿֤ޤ
 *        YĹ2ʬ䤵줿֤ޤ
 *        ûʬ䤷ʤΤޤ
 *        줿ɸˤϡŪʺɸͤˤդޤ
 */
#define drawaxeslb_(sx,ssx,sy,ssy,l,b) do{\
        drawaxisl_(sx,ssx,l,b);drawaxisb_(sy,ssy,l,b);}while(0)

/*
 * (̾) drawaxisix_ --- ؼ
 *        drawaxisiy_ --- ټ
 *
 * () drawaxisi?_( sep, ssep, len, bos )
 *        int sep;      Ĺʬ
 *        int ssep;     ûʬ
 *        int len;      Ĺ
 *        int bos;      ӥ塼ݡȺɸ
 *        
 * () 㤨 setviewport_( 30, 30, 130, 130, 0 ) ¹Ԥ塢
 *        setwindow_( -1.0, 10.0, 1.0, -10.0 ) ǲŪʺɸͤꤷ
 *        drawaxisix_( 2, 0, 6, 0.0 ) Ȥȡ
 *        ӥ塼ݡ(30,30)-(130,130)100X100Ρ
 *        ŪʺɸY=0.0ΰ֤ؼ褵ޤ
 *        ξ硢Ĺ2ʬ䤵줿֤졢
 *        ûޤ
 *        줿ɸˤϡŪʺɸͤˤդޤ
 */
#define drawaxisix_(s,ss,l,b) drawaxisx_(AXIS_INSIDE,s,ss,l,b)
#define drawaxisiy_(s,ss,l,b) drawaxisy_(AXIS_INSIDE,s,ss,l,b)

/*
 * (̾) drawaxesi_ --- ؼټ
 *
 * () drawaxesi_( sepx, ssepx, sepy, ssepy, len, bosx, bosy )
 *        int sepx;     XĹʬ
 *        int ssepx;    Xûʬ
 *        int sepy;     YĹʬ
 *        int ssepy;    Yûʬ
 *        int len;      Ĺ
 *        int bosx;     Xӥ塼ݡȺɸ
 *        int bosy;     Yӥ塼ݡȺɸ
 *        
 * () 㤨 setviewport_( 30, 30, 130, 130, 0 ) ¹Ԥ塢
 *        setwindow_( -1.0, 10.0, 1.0, -10.0 ) ǲŪʺɸͤꤷ
 *        drawaxesi_( 0, 0, 0, 0, 6, 0.0, -0.8 ) Ȥȡ
 *        ӥ塼ݡ(30,30)-(130,130)100X100Ρ
 *        ŪʺɸY=0.0ΰ֤ؼ褵졢
 *        ŪʺɸX=-0.8ΰ֤ټ褵ޤ
 *        ξ硢Ϥޤ
 *        줿ɸˤϡŪʺɸͤˤդޤ
 */
#define drawaxesi_(sx,ssx,sy,ssy,l,bx,by) do{\
        drawaxisix_(sx,ssx,l,bx);drawaxisiy_(sy,ssy,l,by);}while(0)

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

/*
 * (̾) drawaxisx_ --- ɥݡȤأؼ
 *
 * () void drawaxisx_( apos, sep, ssep, len, bos )
 *        int apos;     ɸ֥
 *        int sep;      Ĺʬ
 *        int ssep;     ûʬ
 *        int len;      Ĺ
 *        double bos;   ֥פ AXIS_INSIDE ξ硢褹ֺɸ
 *                      ֥פ AXIS_INSIDE ʳϡӥ塼ݡȤϤ
 *
 * () setviewport_  setwindow_ 줿ɥݡȤˣؼ衣
 *        Ĺ褵줿ɸˤϥեåʸǺɸͤޤ
 *
 *        apos ˤϰʲΰ֥פΤ줫ꤷޤ
 *
 *        enum axis_positions {
 *          AXIS_TOP    = 0, ؼ
 *          AXIS_BOTTOM = 1, ؼ
 *          AXIS_INSIDE = 2, ؼ
 *        };
 *
 *        bos ˤϰ֥פ AXIS_TOPAXIS_BOTTOM Τ줫ξϡ
 *        ɥݡȤϤ;͵(ӥåȿ)ꤷޤ
 *        ֥פ AXIS_INSIDE ξ bos ˤϡ
 *        褹ֺɸꤷޤ
 *         setwindow_ ǻꤷŪʺɸꤷޤ
 *        줿ɸˤϡŪʺɸͤˤդޤ
 */
extern void drawaxisx_( int apos, int sep, int ssep, int len, double bos );

/*
 * (̾) drawaxisy_ --- ɥݡȤأټ
 *
 * () void drawaxisy_( apos, sep, ssep, len, bos )
 *        int apos;     ɸ֥
 *        int sep;      Ĺʬ
 *        int ssep;     ûʬ
 *        int len;      Ĺ
 *        double bos;   ֥פ AXIS_INSIDE ξ硢褹ֺɸ
 *                      ֥פ AXIS_INSIDE ʳϡӥ塼ݡȤϤ
 *
 * () setviewport_  setwindow_ 줿ɥݡȤˣټ衣
 *        Ĺ褵줿ɸˤϥեåʸǺɸͤޤ
 *
 *        apos ˤϰʲΰ֥פΤ줫ꤷޤ
 *
 *        enum axis_positions {
 *          AXIS_LEFT   = 0, ټ
 *          AXIS_RIGHT  = 1, ټ
 *          AXIS_INSIDE = 2, ټ
 *        };
 *
 *        bos ˤϰ֥פ AXIS_LEFTAXIS_RIGHT Τ줫ξϡ
 *        ɥݡȤϤ;͵(ӥåȿ)ꤷޤ
 *        ֥פ AXIS_INSIDE ξ bos ˤϡ
 *        褹ֺɸꤷޤ
 *         setwindow_ ǻꤷŪʺɸꤷޤ
 *        줿ɸˤϡŪʺɸͤˤդޤ
 */
extern void drawaxisy_( int apos, int sep, int ssep, int len, double bos );

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif
