/*
 * Header File < graphl2_.h >
 *
 * Log Space for Borland Graphics Interface
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _GRAPHL2__H_
#define _GRAPHL2__H_
#include <graphr2_.h>

/*
 * (̾) lxtox --- LOG-XɸXɸޥ
 *        lytoy --- LOG-YɸYɸޥ
 *
 * () lxtox(x)
 *        lytoy(y)
 *        double x, y; LOGɸ
 *
 * () 㤨Сsetwindow_( 1E-10, 1E+5, 1E+10, 1E-5 ) ȤƤ
 *        ѴޥѤȥɺɸϤLOGɸȤߤʤ
 *        бɺɸϤκɸ֤ޤ
 */
#define lxtox(x) (log((x)/__W.left)*__W.right/log(__W.right/__W.left))
#define lytoy(y) (log((y)/__W.bottom)*__W.top/log(__W.top/__W.bottom))

/*
 * (̾) linel2_      --- LOG2ɸѴ line     ľޥ
 *        linetol2_    --- LOG2ɸѴ lineto   а֤ؤľޥ
 *        putpixell2_  --- LOG2ɸѴ putpixel ޥ
 *        movetol2_    --- LOG2ɸѴ moveto   ȥݥȰưޥ
 *        outtextxyl2_ --- LOG2ɸѴ outtext  ƥȽϥޥ
 *
 * () linel2_     ( x1,y1, x2,y2 )
 *        linetol2_   ( x,y )
 *        putpixell2_ ( x,y,c )
 *        movetol2_   ( x,y )
 *        outtextxyl2_( x,y,str )
 *        double x1,y1; LOG2ɸ
 *        double x2,y2; LOG2ɸ
 *        double x,y;   LOG2ɸ
 *        int c; ѥåֹ
 *        char *str; ʸ
 *
 * () ³LOG2ɸѴѤΥޥǤ
 *        LOG2դʤɤñ褹뤳ȤǤޤ
 *        ³ϰʲΥѥåưƤޤ
 *        2ɥѴѥå graphr2_.h 
 */
#define linel2_(x0,y0,x1,y1) \
        line_(lxtox(x0),lytoy(y0),lxtox(x1),lytoy(y1))
#define linetol2_(x,y) \
        lineto_(lxtox(x),lytoy(y))
#define rectanglel2_(x0,y0,x1,y1) \
        rectangle_(lxtox(x0),lytoy(y0),lxtox(x1),lytoy(y1))
#define barl2_(x0,y0,x1,y1) \
        bar_(lxtox(x0),lytoy(y0),lxtox(x1),lytoy(y1))
#define putpixell2_(x,y,c) \
        putpixel_(lxtox(x),lytoy(y),c)
#define movetol2_(x,y) \
        moveto_(lxtox(x),lytoy(y))

/*
 * (̾) linelx_      --- LOGXɸѴ line     ľޥ
 *        linetolx_    --- LOGXɸѴ lineto   а֤ؤľޥ
 *        putpixellx_  --- LOGXɸѴ putpixel ޥ
 *        movetolx_    --- LOGXɸѴ moveto   ȥݥȰưޥ
 *        outtextxylx_ --- LOGXɸѴ outtext  ƥȽϥޥ
 *
 * () linelx_     ( x1,y1, x2,y2 )
 *        linetolx_   ( x,y )
 *        putpixellx_ ( x,y,c )
 *        movetolx_   ( x,y )
 *        outtextxylx_( x,y,str )
 *        double x1,y1; LOGXɸ
 *        double x2,y2; LOGXɸ
 *        double x,y;   LOGXɸ
 *        int c; ѥåֹ
 *        char *str; ʸ
 *
 * () ³LOGXɸѴѤΥޥǤ
 *        LOGXդʤɤñ褹뤳ȤǤޤ
 *        ³ϰʲΥѥåưƤޤ
 *        2ɥѴѥå graphr2_.h 
 */
#define linelx_(x0,y0,x1,y1) \
        line_(lxtox(x0),y0,lxtox(x1),y1)
#define linetolx_(x,y) \
        lineto_(lxtox(x),y)
#define rectanglelx_(x0,y0,x1,y1) \
        rectangle_(lxtox(x0),y0,lxtox(x1),y1)
#define barlx_(x0,y0,x1,y1) \
        bar_(lxtox(x0),y0,lxtox(x1),y1)
#define putpixellx_(x,y,c) \
        putpixel_(lxtox(x),y,c)
#define movetolx_(x,y) \
        moveto_(lxtox(x),y)

/*
 * (̾) linely_      --- LOGYɸѴ line     ľޥ
 *        linetoly_    --- LOGYɸѴ lineto   а֤ؤľޥ
 *        putpixelly_  --- LOGYɸѴ putpixel ޥ
 *        movetoly_    --- LOGYɸѴ moveto   ȥݥȰưޥ
 *        outtextxyly_ --- LOGYɸѴ outtext  ƥȽϥޥ
 *
 * () linely_     ( x1,y1, x2,y2 )
 *        linetoly_   ( x,y )
 *        putpixelly_ ( x,y,c )
 *        movetoly_   ( x,y )
 *        outtextxyly_( x,y,str )
 *        double x1,y1; LOGYɸ
 *        double x2,y2; LOGYɸ
 *        double x,y;   LOGYɸ
 *        int c; ѥåֹ
 *        char *str; ʸ
 *
 * () ³LOGYɸѴѤΥޥǤ
 *        LOGYդʤɤñ褹뤳ȤǤޤ
 *        ³ϰʲΥѥåưƤޤ
 *        2ɥѴѥå graphr2_.h 
 */
#define linely_(x0,y0,x1,y1) \
        line_(x0,lytoy(y0),x1,lytoy(y1))
#define linetoly_(x,y) \
        lineto_(x,lytoy(y))
#define rectanglely_(x0,y0,x1,y1) \
        rectangle_(x0,lytoy(y0),x1,lytoy(y1))
#define barly_(x0,y0,x1,y1) \
        bar_(x0,lytoy(y0),x1,lytoy(y1))
#define putpixelly_(x,y,c) \
        putpixel_(x,lytoy(y),c)
#define movetoly_(x,y) \
        moveto_(x,lytoy(y))

#if 0
#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif
#endif

#endif
