/*
 * Header File < graphp3_.h >
 *
 * Perspective Translation on 3-dimensional Rotation Port for BGI
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _GRAPHP3__H_
#define _GRAPHP3__H_
#include <graphr3_.h>

#ifndef RAD
# define RAD(d) (M_PI/180*(d))
#endif

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

/*
  3ƩѴ(3-dimensional Perspective Translation)ѥå
  
  3ɸϤɺɸϤѴ, ƩѴˤä
  ΥˤʪΤαᴶɽѥåǤ.
  Υѥå3Ѵѥå(graphr3_.h)ưޤ.
  ˤ򺮺ߤƻѤǤΤ, 󥿥饯ƥ֤˻Ѵ,ƩѴ
  ڤؤ뤳ȤǽǤ.
  
  ѻԤλΥꤹˤsetdistance_( d )Ȥޤ.
  Υdͤμ¿Ǥ. ͤꤹȽĲȿžƤޤޤ.
  ޤΥdǤ뤳ȤϻʪΤƱɸˤ뤳Ȥˤʤ,
  ͷ׻ǤϥСեˤʤäƤޤΤդƤ.

  㤨Хǥץ쥤˲ۤľ(X:0..1,Y:0..2,Z:0..3)Υ0.5
  ƩѴɽΤǤаʲΤ褦ˤޤ.
    setviewport_( 0, 100, 0, 100, !0 );   ̤100x100ΰȤ
    setmagnify_( 1.5 );                   ƤȤγΨ
    setrotationport_( 0, 0, 0, 1, 2, 3 ); ˾βžΰ
    setrotation( RAD(-15), RAD(20), 0 );  žѤ
    setdistance_( 0.5 );                  Υ
    cubep3_( 0, 0, 0, 1, 2, 3, !0 );      žΰƱľΤ
 */

struct perspectivetype_ {
  double dist;
  double deform;
};

extern struct perspectivetype_ __PP;

/*
 * (̾) p3tox --- 3ɸƩƤ줿Xɸޥ
 *        p3toy --- 3ɸƩƤ줿Yɸޥ
 *        p3toz --- 3ɸƩƤ줿Zɸޥ
 *
 * () p3tox( x,y,z )
 *        p3toy( x,y,z )
 *        p3toz( x,y,z )
 *        double x, y, z; 3ɸ
 *
 * () setmagnify_  setrotation_ ǻꤵ줿žѤǡ
 *        3ɸƩѴ줿3ɸγơκɸޤ
 */
#define p3tox(x,y,z) (r3tox(x,y,z)*__PP.dist/(r3toz(x,y,z)+__PP.deform))
#define p3toy(x,y,z) (r3toy(x,y,z)*__PP.dist/(r3toz(x,y,z)+__PP.deform))
#define p3toz(x,y,z) (__PP.dist*(2.0-__PP.dist/(r3toz(x,y,z)+__PP.deform)))

/*
 * (̾) linep3_      --- 3ƩѴ line     ľޥ
 *        linetop3_    --- 3ƩѴ lineto   а֤ؤľޥ
 *        putpixelp3_  --- 3ƩѴ putpixel ޥ
 *        movetop3_    --- 3ƩѴ moveto   ȥݥȰưޥ
 *        outtextxyp3_ --- 3ƩѴ outtext  ƥȽϥޥ
 *
 * () linep3_     ( x1,y1,z1, x2,y2,z2 )
 *        linetop3_   ( x,y,z )
 *        putpixelp3_ ( x,y,z,c )
 *        movetop3_   ( x,y,z )
 *        outtextxyp3_( x,y,z,str )
 *        double x1,y1,z1; 3ɸ
 *        double x2,y2,z2; 3ɸ
 *        double x,y,z;    3ɸ
 *        int c; ѥåֹ
 *        char *str; ʸ
 *
 * () ³3ƩѴѤΥޥǤ
 *        3ζ֤ο޷ñ褹뤳ȤǤޤ
 *        ³ϰʲΥѥåưƤޤ
 *        3Ѵѥå graphr3_.h 
 */
#define linep3_(x1,y1,z1,x2,y2,z2) \
        line_(p3tox(x1,y1,z1),p3toy(x1,y1,z1), \
	      p3tox(x2,y2,z2),p3toy(x2,y2,z2))
#define linetop3_(x,y,z) \
	lineto_(p3tox(x,y,z),p3toy(x,y,z))
#define putpixelp3_(x,y,z,c) \
        putpixel_(p3tox(x,y,z),p3toy(x,y,z),c)
#define movetop3_(x,y,z) \
        moveto_(p3tox(x,y,z),p3toy(x,y,z))
#define outtextxyp3_(x,y,z,str) \
        outtextxy_(p3tox(x,y,z),p3toy(x,y,z),str)

/*
 * (̾) setdistance_ --- 3ƩѴѡΥ롼
 *
 * () setdistance_( d )
 *        double d; Υ
 *
 * () Υ d μ¿Ǥۤ d = 0.5 餤侩ͤǤ
 *        򾮤3ʪΤ᤯
 *        դ礭ȱ󤯸褦ˤʤޤ
 */
extern void setdistance_( double d );

/*
 * (̾) setdeformation_ --- 3ƩѴѡǥե롼
 *
 * () setdeformation_( d )
 *        double d; ǥե
 *
 * () ǥե d μ¿Ǥۤ d = 2.5 餤侩ͤǤ
 *        򾮤ȱˡζĴٹ礬ޤޤ
 */
extern void setdeformation_( double d );

/*
 * (̾) cubep3_ --- 3ƩѴ cube ľΤ
 *
 * () cubep3_( xf,yf,zf, xt,yt,zt, flg )
 *        double xf,yf,zf; 1
 *        double xt,yt,zt; 2
 *        int flg;         ̤
 *
 * () 3ζ֤12ϤΩΤ3ƩѴ褷ޤ
 */
extern void cubep3_( double xf, double yf, double zf,
                    double xt, double yt, double zt, int flg );

extern void boxp3_( double xf, double yf, double zf, double xt,
                   double yt, double zt, int c6[] );

extern void lefthandp3_( double xf, double yf, double zf,
                        double xt, double yt, double zt, int flg );

/*
 * (̾) linesp3_     --- 3ƩѴ lines     ʣľؿ
 *        putpixelsp3_ --- 3ƩѴ putpixels ʣؿ
 *
 * () linesp3_    ( n, r3points )
 *        putpixelsp3_( n, r3points, c )
 *        int n;                ꤹɸο
 *        double *r3points;     3ɸ¤
 *        int c;                ѥåֹ
 *
 * () 3֤ľꤵ줿ޤȤ褷ޤ
 *        double r3points ˤ3ɸ٥¤ӤǳǼƲ
 */
extern void linesp3_( int __numpoints, double *__r3points );
extern void putpixelsp3_( int __numpoints, double *__r3points, int __color );

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif
