/*
 * Header File < graphrn_.h >
 *
 * n-Dimensional Rotation Port for Borland Graphics Interface
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _GRAPHRN__H_
#define _GRAPHRN__H_
#include <graphr3_.h>
#include <math.h>

#ifndef RAD
# define RAD(d) (M_PI/180*(d))
#endif

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

/*
  nѴ(n-dimensional Rotation Port Translation)ѥå
  
  nɸϤ3ɸϤѴ, 3Ѵѥå
  ǸƤӽФȤˤäƥǥץ쥤n֤ʿƩɽ뤿
  ѥåǤ. ʪΤ˱ᴶƩѴԤȤ,
  ΥѥåǤϤʤƩѴѥågraphpn_.hȤɬפޤ.
  
  ΥѥåŪǤդn֤ǥץ쥤Ƥ뤳ȤǤ.
  Ǥդn֤ǤΤǤΩΤǤɬפϤޤ.
  Ǽ¿n֤nĶžΰ(n-Hyper Rotation Port)ȸƤӤޤ.
  ΥѥåǤϤβžΰƼʬ˲žѴܤ
  3ɸϤĶΩΤȤƤޤ.
  㤨Хǥץ쥤˲ۤĶľ(X:0..1,Y:0..2,Z:0..3,W:0..4)ˤ
  ʲΤ褦ˤޤ.
    double xf[4] = { 0, 0, 0, 0 };
    double xt[4] = { 1, 2, 3, 4 };
    setviewport_( 0, 100, 0, 100, !0 );           ̤100x100ΰȤ
    hypermagnify_( 1.5 );                         ƤȤγΨ
    hyperrotationport_( 4, xf, xt );              ˾βžΰ
    setrotation_( RAD(-15), RAD(20), 0 );         žѤ(X,Y,Z)
    hyperrotate_( 0, 3, RAD(-15) );               žѤ(XW)
    hyperrotate_( 1, 3, RAD(-30) );               žѤ(YW)
    hyperrotate_( 2, 3, RAD(+10) );               žѤ(ZW)
    cubern_( 4, xf, xt, !0 );                     žΰƱľΤ

  褷ĶľΤž hyperrotation_ ٻꤷ,
  cubern_ 褹뤳Ȥˤä̤βžѤĶľΤȤǤޤ.
  ʤߤRADϥǥ꡼饸ѴޥǤ.
 */

struct hyperrotationporttype_ {
  double dim; /* n-dimensional rotation port */
  double *o;  /* region origin */
  double *m;  /* region magnify */
  double mag; /* rotation port magnify */
  double **r; /* rotation matrix */
  double **a; /* work matrix to rotate */
  double *x;  /* work to translate */
  double *y;  /* work to translate */
  double *z;  /* work to translate */
};

/*
 * (̾) rntov --- nɸƤ줿ɸؿ
 *
 * () rntov( src, dst )
 *        double *src; nɸ(٥ȥǳǼ)
 *        double *dst; nɸ(٥ȥǳǼ)
 *
 * () hypermagnify_  hyperrotate_ ǻꤵ줿žѤǡ
 *        nɸž줿nɸκɸ٥ȥǵޤ
 */
extern void rntov( double *xsrc, double *xdst );

/*
 * (̾) linern_      --- nѴ line     ľؿ
 *        linetorn_    --- nѴ lineto   а֤ؤľؿ
 *        putpixelrn_  --- nѴ putpixel ؿ
 *        movetorn_    --- nѴ moveto   ȥݥȰưؿ
 *        outtextxyrn_ --- nѴ outtext  ƥȽϴؿ
 *
 * () linern_     ( x1,x2 )
 *        linetorn_   ( x )
 *        putpixelrn_ ( x,c )
 *        movetorn_   ( x )
 *        outtextxyrn_( x,str )
 *        double *x1; nɸ(٥ȥǳǼ)
 *        double *x2; nɸ(٥ȥǳǼ)
 *        double *x;  nɸ(٥ȥǳǼ)
 *        int c; ѥåֹ
 *        char *str; ʸ
 *
 * () ³nѴѤδؿǤ
 *        nĶ֤ο޷ñ褹뤳ȤǤޤ
 *        ³ϰʲΥѥåưƤޤ
 *        3ƩѴѥå graphr3_.h 
 */
extern void linern_( double *x1, double *x2 );
extern void linetorn_( double *x );
extern void putpixelrn_( double *x, int c );
extern void movetorn_( double *x );
extern void outtextxyrn_( double *x, char *str );

/*
 * (̾) hyperrotationport_ --- nƩѴѡɸ롼
 *
 * () hyperrotationport_( xf, xt )
 *        double *xf; 1(٥ȥǳǼ)
 *        double *xt; 2(٥ȥǳǼ)
 *
 * () 12ϤĶΩΤnƩѴΰȤޤ
 */
extern void hyperrotationport_( int dim, double *xf, double *xt );

/*
 * (̾) hypermagnify_ --- nƩѴѡΨ롼
 *
 * () hypermagnify_( nhm )
 *        double nhm; Ψ
 *
 * () nʪΤ3ƩƤȤγΨꤷޤ
 *        nhm = 1.0 ΤȤʿƤȤʤޤѴؿ
 *        ºݤ˥ǥץ쥤褵줿Ȥ˾ޤΤǡ
 *        nhm = 1.5 餤礦ɤǤ礦
 */
extern void hypermagnify_( double nhm );

/*
 * (̾) hyperrotation_ --- nƩѴѡƳѻ롼
 *
 * () hyperrotation_( n, fa, ta, angle );
 *        int n;         žο
 *        int *fa, *ta;  žμź(fataؤβž)Υꥹ
 *        double *angle; žѤΥꥹ
 *
 * () nʪΤ3ƩƤȤƳѤꤷޤ
 */
void hyperrotation_( int n, int *fx, int *tx, double *angle );

/*
 * (̾) hyperrotate_ --- nƩѴѡǤռž롼
 *
 * () hyperrotation_( fa, ta, angle );
 *        int fa, ta;   žμź(fataؤβž)
 *        double angle; ž
 *
 * () nʪΤ3ƩƤȤβžѤꤷޤ
 *        ȤƳѤꤵ줿٤žޤ
 */
extern void hyperrotate( int fa, int ta, double angle );

/*
 * (̾) cubern_ --- nѴ cube ľΤ
 *
 * () cubern_( xf, xt, flg )
 *        double xf; 1(٥ȥǳǼ)
 *        double xt; 2(٥ȥǳǼ)
 *        int flg;   !0ξʬ򥫥顼ɽ
 *
 * () nĶ֤12ϤĶΩΤnѴ褷ޤ
 */
extern void cubern_( double *xf, double *xt, int flg );

/*
 * (̾) linesrn_     --- nѴ lines     ʣľؿ
 *        putpixelsrn_ --- nѴ putpixels ʣؿ
 *
 * () linesrn_    ( np, rnpoints )
 *        putpixelsrn_( np, rnpoints, c )
 *        int np;            ꤹɸο
 *        double **rnpoints; nɸΥ٥ȥ
 *        int c;             ѥåֹ
 *
 * () n֤ľꤵ줿ޤȤ褷ޤ
 *        doubleι rnpoints ˤnɸ
 *        rnpoints[0..np-1][0..n-1] ǳǼƲ
 */
extern void linesrn_( int np, double **rnpoints );
extern void putpixelsrn_( int np, double **rnpoints, int c );

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif 
