/*
 * Source File < graphr2_.c >
 *
 * R2 Window Port with Floating Point for Borland Graphics Interface
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#include <graphr2_.h>
#ifdef _XBGI_
#include <graphix.h>
#endif
#ifdef _XBGI_
#include "xbgidef.h"
#endif

#define w __W
#define v __V

struct windowtype_ w = { 0, 0, 639, 399, 639, 399 };
struct viewporttype_ v = { 0, 0, 639, 399, !0 };

#ifdef CREATE_FUNCTION_FROM_MACRO
int (wvx)( double x )
{
  return wvx(x);
}
int (wvy)( double y )
{
  return wvy(y);
}
int (f_x)( double x )
{
  return f_x(x);
}
int (f_y)( double y )
{
  return f_y(y);
}

double (vwx)( int x )
{
  return vwx(x);
}
double (vwy)( int y )
{
  return vwy(y);
}
double (x_f)( int x )
{
  return x_f(x);
}
double (y_f)( int y )
{
  return y_f(y);
}

void (arc_)(double x,double y,double stt,double end,double r)
{
  arc_(x,y,stt,end,r);
}
void (bar_)(double x1,double y1,double x2,double y2)
{
  bar_(x1,y1,x2,y2);
}
void (bar3d_)(double x1,double y1,double x2,double y2,double w,int flg)
{
  bar3d_(x1,y1,x2,y2,w,flg);
}
void (circle_)(double x,double y,double r)
{
  circle_(x,y,r);
}

#if 0
void (closegraph_)(void)
{
  closegraph_();
}
void (clearviewport_)(void)
{
  clearviewport_();
}
#endif

void (ellipse_)(double x,double y,double stt,double end,double xr,double yr)
{
  ellipse_(x,y,stt,end,xr,yr);
}
void (fillellipse_)(double x,double y,double xr,double yr)
{
  fillellipse_(x,y,xr,yr);
}
void (floodfill_)(double x,double y,int border)
{
  floodfill_(x,y,border);
}

void (getimage_)(double x1,double y1,double x2,double y2,void *bm)
{
  getimage_(x1,y1,x2,y2,bm);
}

double (getmaxx_)( void )
{
  return getmaxx_();
}
double (getmaxy_)( void )
{
  return getmaxy_();
}

int (getpixel_)(double x,double y)
{
  return getpixel(wvx(x),wvy(y));
}

double (getx_)( void )
{
  return vwx(getx());
}
double (gety_)( void )
{
  return vwy(gety());
}

int (imagesize_)(x1,y1,x2,y2)
{
  return imagesize(wvx(x1),wvy(y1),wvx(x2),wvy(y2));
}

void (line_)(double x1,double y1,double x2,double y2)
{
  line_(x1,y1,x2,y2);
}
void (lineto_)(double x,double y)
{
  lineto_(x,y);
}
void (moverel_)(double dx,double dy)
{
  moverel_(dx,dy);
}
void (moveto_)(double x,double y)
{
  moveto_(x,y);
}
void (outtextxy_)(double x,double y,char *textstring)
{
  outtextxy_(x,y,textstring);
}
void (pieslice_)(double x,double y,double stt,double end,double r)
{
  pieslice_(x,y,stt,end,r);
}
void (putimage_)(double x,double y,void *bm,int op)
{
  putimage_(x,y,bm,op);
}
void (putpixel_)(double x,double y,int c)
{
  putpixel_(x,y,c);
}
void (rectangle_)(double x1,double y1,double x2,double y2)
{
  rectangle_(x1,y1,x2,y2);
}

void (sector_)(double x,double y,double stt,double end,double xr,double yr)
{
  sector_(x,y,stt,end,xr,yr);
}

void (setaspectratio_)(double x,double y)
{
  setaspectratio_(x,y);
}

void (setusercharsize_)(double x,double dx,double y,double dy)
{
  setusercharsize_(x,dx,y,dy);
}

double (textheight_)(char *xxx)
{
  return x_f(textheight(xxx));
}
double (textwidth_)(char *xxx)
{
  return y_f(textwidth(xxx));
}
#endif /* CREATE_FUNCTION_FROM_MACRO */

void drawpoly_( int n, double *dp )
{
  int i, *ip;
  
  ip = (int*)malloc(2*n*sizeof(int));
  for ( i=0; i<2*n; i++ )
    ip[i] = (i%2==0)?wvx(dp[i]):wvy(dp[i]);
  drawpoly( n, ip );
  free( ip );
}
void fillpoly_( int n, double *dp )
{
  int i, *ip;

  ip = (int*)malloc(2*n*sizeof(int));
  for ( i=0; i<2*n; i++ )
    ip[i] = (i%2==0)?wvx(dp[i]):wvy(dp[i]);
  fillpoly( n, ip );
  free( ip );
}
void setviewport_( double left, double top,
		  double right, double bottom, int clip )
{
  setviewport( (int)left, (int)top, (int)right, (int)bottom, clip );
  v.left   = left;
  v.top    = top;
  v.right  = right;
  v.bottom = bottom;
  v.clip   = clip;
  w.mx = (v.right-v.left)/(w.right-w.left);
  w.my = (v.bottom-v.top)/(w.bottom-w.top);
}
void setwindow_( double left, double top, double right, double bottom )
{
  w.left   = left;
  w.top    = top;
  w.right  = right;
  w.bottom = bottom;
  w.mx = (v.right-v.left)/(w.right-w.left);
  w.my = (v.bottom-v.top)/(w.bottom-w.top);
}
void initgraph_( int *gd, int *gm, char *gp )
{
  int gerr;

  initgraph( gd, gm, gp );
  gerr = graphresult();
  if ( gerr != grOk ) return;
  setviewport_( 0, 0, getmaxx_(), getmaxy_(), !0 );
  setwindow_( 0, 0, getmaxx_(), getmaxy_() );
}

#ifdef _XBGI_
xbgi *creategraph_( int *gd, int *gm, char *gp )
{
  int gerr;
  xbgi *this;

  this = creategraph( gd, gm, gp );
  gerr = graphresult();
  if ( gerr != grOk ) return NULL;
  setviewport_( 0, 0, getmaxx_(), getmaxy_(), !0 );
  setwindow_( 0, 0, getmaxx_(), getmaxy_() );
  return( this );
}
#endif

void getwindowsettings_( struct windowtype_ *wp )
{
  *wp = w;
}

void getviewsettings_( struct viewporttype_ *vp )
{
  *vp = v;
}

void setviewportclip( int clip )
{
  struct viewporttype cv;

  getviewsettings( &cv );
  setviewport( cv.left, cv.top, cv.right, cv.bottom, clip );
}

void lines_( int n, double *r2points )
{
#ifdef _XBGI_
  XPoint *xpoints = (XPoint *)malloc( n*sizeof(XPoint) );
  int i;
  extern xbgi *XBGI;
  
  for ( i=0; i<n; i++ ){
    xpoints[i].x
      = Xx(wvx(r2points[2*i+0]));
    xpoints[i].y
      = Xy(wvy(r2points[2*i+1]));
  }
  XDrawLines( XBGIDisplay, XBGIWins[XBGI->apage], XBGIDrawGC,
	     xpoints, n, CoordModeOrigin );
  free( xpoints );
#else
  int i;

  for ( i=0; i<n-2; i++ )
    line_( r2points[2*i+0], r2points[2*i+1],
	  r2points[2*(i+1)+0], r2points[2*(i+1)+1] );
#endif
}

extern void putpixels_( int n, double *r2points, int color )
{
#ifdef _XBGI_
  XPoint *xpoints = (XPoint *)malloc( n*sizeof(XPoint) );
  int i;
  extern xbgi *XBGI;
  
  XSetForeground( XBGIDisplay, XBGIPixelGC,
                 XBGIPixels[minmax(0,color,XBGI->palette.size-1)] );
  for ( i=0; i<n; i++ ){
    xpoints[i].x
      = Xx(wvx(r2points[2*i+0]));
    xpoints[i].y
      = Xy(wvy(r2points[2*i+1]));
  }
  XDrawPoints( XBGIDisplay, XBGIWins[XBGI->apage], XBGIPixelGC,
	      xpoints, n, CoordModeOrigin );
  free( xpoints );
#else
  int i;

  for ( i=0; i<n; i++ )
    putpixel_( r2points[2*i+0], r2points[2*i+1], color );
#endif
}

#undef w
#undef v

