/*
 * Routines to analyse command line options < option.h >
 *
 * ޥɥ饤󥪥ץϤΤΥ롼
 *
 * Copyright (c) 1992 Taiji YAMADA
 */
#ifndef _OPTION_H_
#define _OPTION_H_

/*
 * (̾) scan_option --- ʰץץϥ롼
 *
 * ()
 *        #include <option.h>
 *        int scan_option( argc, argv, key, ... )
 *        int argc;      ޥɥ饤ο
 *        char *argv[];  ޥɥ饤
 *        char *key, ... ɽʸȲѰ
 *
 * ()
 *        1. ޥɥ饤󥪥ץ˻ꤵ줿¸ߤ,
 *           ֤ޤ.
 *      () ޥɥ饤 "-help" ꤵƤ
 *             scan_option( argc, argv, "-help" )
 *           ֤ͤޤ.
 *
 *        2. ޥɥ饤󥪥ץ˻ꤵ줿¸ߤ,
 *           Υ scanf 񼰤ľ, θ˻ꤵ줿Ѱ
 *           ޥɥ饤ͤ򥻥åȤ, ֤ޤ.
 *      () ޥɥ饤 "-geom 100x100" ꤵƤȤ,
 *             scan_option( argc, argv, "-geom %dx%d", &W, &H ) ֤,
 *           W, H ˤϤ줾 100, 100 ޤ.
 */
/*
 * (NAME) scan_option --- analyse command line options routine
 *
 * (SYNOPSIS)
 *        #include <option.h>
 *        int scan_option( argc, argv, key, ... )
 *        int argc;      ޥɥ饤ο
 *        char *argv[];  ޥɥ饤
 *        char *key, ... ɽʸ
 *
 * (DESCRIPTION)
 *        1. If there is key to scan in command line options,
 *           true(=!0) is returned.
 *      (ex) If there is "-help" in command line options,
 *             scan_option( argc, argv, "-help" );
 *           This procedure returns !0.
 *
 *        2. If there is key to scan with "scanf format",
 *           varable(s) is(are) scaned and !0 is returned.
 *      (ex) If there is "-geom 100x100" in command line options,
 *             scan_option( argc, argv, "-geom %dx%d", &W, &H );
 *           This procedure returns !0 and
 *           sets 100 and 100 in W and H, respectively.
 */
extern int scan_option( int argc, char *argv[], char *key, ... );

#endif /* _OPTION_H_ */
