/*
 * Header File < xbgiutl.h >
 *
 * XBGI Utilities Functions: Borland Graphics Interface for Xlib
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _XBGIUTL_H_
#define _XBGIUTL_H_
#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#ifndef NeedFunctionPrototypes
#  if defined(__STDC__) || defined(__cplusplus) || defined(c_plusplus)
#    define NeedFunctionPrototypes 1
#  else
#    define NeedFunctionPrototypes 0
#  endif
#endif

#define DecoNothing   0
#define DecoRectFront 1
#define DecoRectBack  2

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

extern int XSetIconFromPixmap(
#if NeedFunctionPrototypes
  Display *__d, Window __r, Pixmap __pm, unsigned int __w, unsigned int __h
#endif
);

extern void xbgiGetSizeVPrintf(
#if NeedFunctionPrototypes
  XFontStruct *__fs, int *__width, int *__height, char *__fmt, va_list __argptr
#endif
);

extern void xbgiGetSizePrintf(
#if NeedFunctionPrototypes
  XFontStruct *__fs, int *__width, int *__height, char *__fmt, ...
#endif
);

extern void xbgiVPrintf(
#if NeedFunctionPrototypes
  Display *__display, Window __win, GC __gc, XFontStruct *__fs,
  int __textjust, char *__fmt, va_list __argptr
#endif
);

extern void xbgiPrintf(
#if NeedFunctionPrototypes
  Display *__display, Window __win, GC __gc, XFontStruct *__fs,
  int __textjust, char *__fmt, ...
#endif
);

extern void xbgiDecorateWindow(
#if NeedFunctionPrototypes
  Display *__display, Window __win, GC __gc,
  unsigned long __fg, unsigned long __lc, unsigned long __dc, int __type
#endif
);

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif /* _XBGIUTL_H_ */

