/*
 * Sample Program of BGI library for both BGI and XBGI < attract.c >
 *
 * BGI ΤΥ饤֥ graphr2_.h, coloring.h Υץ
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <setjmp.h>
#include <conio.h>
#include <graphics.h>
#include <graphr2_.h> /* R^2֤򥵥ݡȤ륤󥯥롼ɥե */
#include <coloring.h> /* ѥåȤ򰷤Υġ */

#define BTIME 500
#define ITIME 100
int MAXCOLOR;
jmp_buf jumper;

double p[2*ITIME];
int itime;

/*
 * ʸ
 * F. Aicardi and S. Invernizzi:
 *  ``Memory effects in discrete dynamical systems'',
 *  International Journal of Bifucation and Chaos, 2, 4, 815-830 (1992)
 * R. M. May:
 *  ``Simple mathematical models with very complicated dynamics'',
 *  Nature, 261, 459-467 (1976)
 */
double A, B = 0.8, X0, X1, X2;
#define F(x) A*(x)*(1.0-(x))
#define G(x1,x0) F((1.0-B)*x1+B*x0)

void iterate( void )
{
  int t;
  
  for ( t=0; t<10; t++ ){
    X2 = G(X1,X0);
    X0 = X1;
    X1 = X2;
  }
  for ( t=0; t<ITIME; t++ ){
    X2 = G(X1,X0);
    p[2*t+0] = X1;
    p[2*t+1] = X2;
    X0 = X1;
    X1 = X2;
    if ( kbhit() && getch() == 0x1b )
      longjmp( jumper, 1 );
    itime = t;
  }
}

void bifurcate( void )
{
  int b;

  for ( b=0; b<BTIME; b++ ){
    A = 3.0 + (4.0-3.0)*b/BTIME;
    X0 = 0.1;
    X1 = 0.2;
    iterate();
    putpixels_( itime, p, b%(MAXCOLOR-1)+1 ); /* ɸؤ */
  }
}

int main( void )
{
  int gd = DETECT, gm, i;
  int jump_val;

  initgraph_( &gd, &gm, "-geometry 400x400" );
  MAXCOLOR = getmaxcolor();
  coloring( 1, MAXCOLOR-1 ); /* RGBǡ󥫥顼κ */
  setviewport_( 0, 0, 400-1, 400-1, !0 ); /* ʪɸ */
  setwindow_( 0.0, 1.0, 1.0, 0.0 ); /* ɸ */

  jump_val = setjmp( jumper );
  if ( jump_val == 0 ){
    bifurcate();
    (void)getch();
  }

  closegraph_();
  return 0;
}
