/*
 * Routines to analyse command line options < option.h >
 *
 * ޥɥ饤󥪥ץϤΤΥ롼
 *
 * Copyright (c) 1992 Taiji YAMADA
 */
#include <stdarg.h>
#include <string.h>
#include <malloc.h>

int scan_option( int argc, char *argv[], char *key, ... )
{
  int i, idx;
  char opt[64], fmt[64], buf[256], *ptr;
  va_list argptr;
#ifndef ENABLE_VSSCANF
#define VLIST10(V) V[0],V[1],V[2],V[3],V[4],V[5],V[6],V[7],V[8],V[9]
  int c;
  void **val;
#endif

  strcpy( opt, key );
  if ( (ptr=strchr(opt,'%')) != NULL ){
    strcpy( fmt, ptr );
    *ptr = '\0';
    while ( *(--ptr)==' ' ) *ptr = '\0';
  }else{
    for ( i=1; i<argc; i++ )
      if ( strcmp( argv[i], key )==0 )
        return i;
    return( 0 );
  }

#ifndef ENABLE_VSSCANF
  c = 0;
  ptr = strchr( fmt, '%' );
  while ( ptr != NULL ){
    c++;
    ptr = strchr( ptr+1, '%' );
  }
  val = (void**)malloc( (c+1)*sizeof(void*) );
  va_start( argptr, key );
  for ( i=0; i<c; i++ ){
    val[i] = va_arg( argptr, void* );
  }
  val[i] = NULL;
  va_end( argptr );
#endif

  idx = 0;
  for ( i=1; i<argc; i++ )
    if ( strcmp( argv[i], opt )==0 ){
      strcpy( buf, "" );
      idx = i;
      while ( ++i < argc ){
        strcat( buf, argv[i] );
        strcat( buf, " " );
      }
#ifdef ENABLE_VSSCANF
      va_start( argptr, key );
      vsscanf( buf, fmt, argptr );
      va_end( argptr );
#else
      sscanf( buf, fmt, VLIST10(val) );
#endif
      break;
    }
#ifndef ENABLE_VSSCANF
  free( val );
#undef VLIST10
#endif
  return idx;
  /*
   * following methods do not work in place of vsscanf
   *  sscanf ( buf, fmt, _va_ptr );
   *  sscanf ( buf, fmt, argptr  );
   *  vfscanf( buf, fmt, argptr  );
   */
}
