#include <stdio.h>
#include <option.h>

/*
 * global variables for example
 */
char TITLE[64] = "test program of option.h";
char NAME[64]  = "option0";
char c = 'c';
int flag = 0;
int WIDTH = 500, HEIGHT = 400;
double D = 0.001;

/*
 * to show variables for example
 */
void usage( FILE *fp )
{
  fprintf( fp, "program to check the options.h <options0> \n" );
  fprintf( fp, "usage ... \n" );
  fprintf( fp, "\t-title title: to set string (%s).   \n", TITLE );
  fprintf( fp, "\t-name name:   to set string (%s).   \n", NAME );
  fprintf( fp, "\t-c char:      to set character (%c).\n", c );
  fprintf( fp, "\t-on:          to set flag (%s).     \n", flag?"YES":"NO" );
  fprintf( fp, "\t-geom WxH:    to set ints (%1dx%1d).\n", WIDTH, HEIGHT );
  fprintf( fp, "\t-D float:     to set float (%f).    \n", D );
  fprintf( fp, "\t-help:        show this help.       \n" );
}

void main( int argc, char *argv[] )
{
  /*
   * procedures for an example
   */
  printf( "\n*** DEFAULT SETTINGS ***\n\n" );
  usage( stdout );
  /*
   * analyze options and get results
   */
  /*
   * analyze options
   */
  scan_option( argc, argv, "-title %s", TITLE );
  scan_option( argc, argv, "-name %s", NAME );
  scan_option( argc, argv, "-c %c", &c );
  scan_option( argc, argv, "-on", &flag );
  scan_option( argc, argv, "-geom %dx%d", &WIDTH, &HEIGHT );
  scan_option( argc, argv, "-D %lf", &D );
  if ( scan_option( argc, argv, "-help" ) ){
    fprintf( stdout, "\nThere is help option.\n\n" );
    usage( stdout );
    exit( 0 );
  }
  /*
   * procedures for an example
   */
  printf( "\n*** SETTINGS BY YOUR OPTIONS ***\n\n" );
  usage( stdout );

  exit( 0 );
}
