#include <stdio.h>
#include <options.h>

/*
 * global variables for example
 */
char TITLE[64] = "test program of options.h";
char NAME[64]  = "options0";
char c = 'c';
int flag = 0;
int WIDTH = 500, HEIGHT = 400;
double D = 0.001;

/*
 * packed technique of options
 */
option_record options[] = {
  { "-name %s", NAME  },
  { "-c %c",    &c    },
  { "-on",      &flag },
  { "-D %f",    &D    },
  { "-help",    NULL  }
};

/*
 * to show variables for example
 */
void usage( FILE *fp )
{
  fprintf( fp, "program to check the options.h <options0> \n" );
  fprintf( fp, "usage ... \n" );
  fprintf( fp, "\t-title title: to set string (%s).   \n", TITLE );
  fprintf( fp, "\t-name name:   to set string (%s).   \n", NAME );
  fprintf( fp, "\t-c char:      to set character (%c).\n", c );
  fprintf( fp, "\t-on:          to set flag (%s).     \n", flag?"YES":"NO" );
  fprintf( fp, "\t-geom WxH:    to set ints (%1dx%1d).\n", WIDTH, HEIGHT );
  fprintf( fp, "\t-D float:     to set float (%f).    \n", D );
  fprintf( fp, "\t-help:        show this help.       \n" );
}

void main( int argc, char *argv[] )
{
  /*
   * entry options
   */
  set_option( "-title %s", TITLE );
  set_options( 3, options );
  set_option( "-geom %dx%d", &WIDTH, &HEIGHT );
  /*
   * procedures for an example
   */
  printf( "\n*** DEFAULT SETTINGS ***\n\n" );
  usage( stdout );
  /*
   * analyze options and get results
   */
  scan_options( argc, argv );
  if ( is_option( "-help" ) ){
    fprintf( stdout, "\nThere is help option.\n\n" );
    usage( stdout );
    exit( 0 );
  }
  /*
   * procedures for an example
   */
  printf( "\n*** SETTINGS BY YOUR OPTIONS ***\n\n" );
  usage( stdout );
  /*
   * closing options routines
   */
  reset_options();

  exit( 0 );
}
