/*
 * Source File < bgiutl.c >
 *
 * BGI Utilities Functions: Borland Graphics Interface for Xlib
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#include "_bgi.h"

void bgipoints2XPoints( int n, int polypoints[], XPoint *xpoints )
{
  int i;

  for ( i=0; i<n; i++ ){
    xpoints->x = Xx( *polypoints++ );
    xpoints->y = Xy( *polypoints++ );
    xpoints++;
  }
}
void bgivprintf( char *title, int textjust, char *fmt, va_list argptr )
{
  Window rwin, twin, pwin;
  XEvent ev;
  int i, mwidth, twidth, theight, pwidth, pheight;
  int x, y;
  
  xbgiGetSizePrintf( XBGIFontStruct, &pwidth, &pheight, title );
  xbgiGetSizeVPrintf( XBGIFontStruct, &twidth, &theight, fmt, argptr );
  mwidth = max( twidth, pwidth );
  x = XBGIEvent.xkey.x_root;
  y = XBGIEvent.xkey.y_root;
  x = x - Hem(mwidth)/2;
  y = y - Hem(theight)/2;
  rwin = XCreateSimpleWindow( XBGIDisplay, RootWindow(XBGIDisplay,XBGIScreen),
                             x, y,
                             Hem(Hem(mwidth)), Hem(Hem(pheight)+Hem(theight)),
                             0, XBGIForeground, XBGIBackground );
  XSelectInput( XBGIDisplay, rwin, ExposureMask|ButtonPressMask );
  twin = XCreateSimpleWindow( XBGIDisplay, rwin, 
                             DecoHemBits, DecoHemBits,
                             Hem(mwidth), Hem(pheight), 0,
                             XBGIForeground, XBGIBackground );
  pwin = XCreateSimpleWindow( XBGIDisplay, rwin, 
                             DecoHemBits, DecoHemBits+Hem(pheight), 
                             Hem(mwidth), Hem(theight),
                             0, XBGIForeground, XBGIBackground );
  XMapWindow( XBGIDisplay, rwin );
  XMapSubwindows( XBGIDisplay, rwin );
  XSetTransientForHint( XBGIDisplay, rwin, XBGIRoot );

  XFlush( XBGIDisplay );
  while (1){
    XNextEvent( XBGIDisplay, &ev );
    switch ( ev.type ){
    case Expose:
      xbgiDecorateWindow( XBGIDisplay, rwin, XBGIDefaultGC,
                         XBGIForeground, XBGITopShadow, XBGIBottomShadow,
			 DecoRectFront );
      xbgiDecorateWindow( XBGIDisplay, twin, XBGIDefaultGC,
                         XBGIForeground, XBGITopShadow, XBGIBottomShadow,
			 DecoRectFront );
      xbgiPrintf( XBGIDisplay, twin, XBGIDefaultGC, XBGIFontStruct,
		 CENTER_TEXT, "%s", title );
      xbgiDecorateWindow( XBGIDisplay, pwin, XBGIDefaultGC,
                         XBGIForeground, XBGITopShadow, XBGIBottomShadow,
			 DecoNothing );
      xbgiVPrintf( XBGIDisplay, pwin, XBGIDefaultGC, XBGIFontStruct, textjust,
                  fmt, argptr );
      break;      
    case ButtonPress:
    case KeyPress:
      XUnmapSubwindows( XBGIDisplay, rwin );
      XUnmapWindow( XBGIDisplay, rwin );
      XDestroySubwindows( XBGIDisplay, rwin );
      XDestroyWindow( XBGIDisplay, rwin );
      return;
    }
  }
}
void bgiprintf( char *title, int textjust, char *fmt, ... )
{
  va_list argptr;
  
  va_start( argptr, fmt );
  bgivprintf( title, textjust, fmt, argptr );
  va_end( argptr );
}
void bgigets( char *title, int maxlen, char *str )
{
  char *OK = " ok ", *CANCEL = " cancel ";
  Window rwin, twin, swin, owin, cwin;
  XSetWindowAttributes att;
  Cursor curs;
  XEvent ev, exposeev;
  char *bytes = NULL, c;
  KeySym key;
  int nbytes, width, height, textwidth, textheight, textstartx, textstarty;
  int x, y, owidth, cwidth;
  Time clicktime;
  int flg = !0;

  textwidth  = TextWidth( XBGIFontStruct, "_", 1 )*20;
  textheight = TextHeight( XBGIFontStruct );
  width  = Brim( textwidth  );
  height = Brim( textheight );
  textstartx = HemBrim;
  textstarty = HemBrim + TextAscent(XBGIFontStruct);
  x = XBGIEvent.xbutton.x_root;
  y = XBGIEvent.xbutton.y_root;
  x = x - Hem(width)/2;
  y = y - Hem(height)/2;
  owidth = Brim( TextWidth(XBGIFontStruct,OK,    strlen(OK)    ) );
  cwidth = Brim( TextWidth(XBGIFontStruct,CANCEL,strlen(CANCEL)) );
  rwin = XCreateSimpleWindow( XBGIDisplay, RootWindow( XBGIDisplay, 0 ),
                             x, y, Hem(Hem(width)), Hem(3*Hem(height)), 0,
                             XBGIForeground, XBGIBackground );
  XSelectInput( XBGIDisplay, rwin, KeyPressMask|ButtonPressMask );
  twin = XCreateSimpleWindow( XBGIDisplay, rwin,
                             DecoHemBits, DecoHemBits,
                             Hem(width), Hem(height), 0,
                             XBGIForeground, XBGIBackground );
  swin = XCreateSimpleWindow( XBGIDisplay, rwin,
                             DecoHemBits, DecoHemBits+Hem(height),
                             Hem(width), Hem(height), 0,
                             XBGIForeground, XBGIBackground );
  owin = XCreateSimpleWindow( XBGIDisplay, rwin,
                             DecoHemBits, DecoHemBits+2*Hem(height),
                             Hem(owidth), Hem(height), 0,
			     XBGIForeground, XBGIBackground );
  cwin = XCreateSimpleWindow( XBGIDisplay, rwin,
                             DecoHemBits+Hem(owidth),
                             DecoHemBits+2*Hem(height),
                             Hem(cwidth), Hem(height), 0,
			     XBGIForeground, XBGIBackground );
  XSelectInput( XBGIDisplay, twin, ExposureMask|KeyPressMask|ButtonPressMask );
  XSelectInput( XBGIDisplay, swin, ExposureMask|KeyPressMask|ButtonPressMask );
  XSelectInput( XBGIDisplay, owin, ExposureMask|KeyPressMask|ButtonPressMask );
  XSelectInput( XBGIDisplay, cwin, ExposureMask|KeyPressMask|ButtonPressMask );
  curs = XCreateFontCursor( XBGIDisplay, XC_xterm );
  XDefineCursor( XBGIDisplay, swin, curs );
  XFlush( XBGIDisplay );
  XMapWindow( XBGIDisplay, rwin );
  XMapSubwindows( XBGIDisplay, rwin );
  XSetTransientForHint( XBGIDisplay, rwin, XBGIRoot );
  do
    XNextEvent( XBGIDisplay, &ev );
  while ( ev.type != Expose );
  XPutBackEvent( XBGIDisplay, &ev );

  XFlush( XBGIDisplay );
  while ( flg ){
    XNextEvent( XBGIDisplay, &ev );
    switch ( ev.type ){
    case Expose:
      textwidth = TextWidth( XBGIFontStruct, str, strlen(str) )
        + TextWidth( XBGIFontStruct, " ", 1 );
      if ( textwidth < width )
        textstartx = 0;
      else
        textstartx = width - textwidth;
      if ( ev.xexpose.window == rwin ){
        xbgiDecorateWindow( XBGIDisplay, rwin, XBGIDefaultGC,
                           XBGIForeground, XBGITopShadow, XBGIBottomShadow,
			   DecoRectFront );
      }else if ( ev.xexpose.window == twin ){
        xbgiDecorateWindow( XBGIDisplay, twin, XBGIDefaultGC,
                           XBGIForeground, XBGITopShadow, XBGIBottomShadow,
			   DecoRectFront );
        xbgiPrintf( XBGIDisplay, twin, XBGIDefaultGC, XBGIFontStruct,
		   CENTER_TEXT, "%s", title );
      }else if ( ev.xexpose.window == swin ){
        exposeev = ev;
        xbgiDecorateWindow( XBGIDisplay, swin, XBGIDefaultGC,
                           XBGIForeground, XBGITopShadow, XBGIBottomShadow,
			   DecoRectBack );
        XSetForeground( XBGIDisplay, XBGIDefaultGC, XBGIForeground );
        XSetBackground( XBGIDisplay, XBGIDefaultGC, XBGIBackground );
        XDrawString( XBGIDisplay, swin, XBGIDefaultGC, textstartx, textstarty,
                    str, strlen(str) );
        XSetForeground( XBGIDisplay, XBGIDefaultGC, XBGIBackground );
        XSetBackground( XBGIDisplay, XBGIDefaultGC, XBGIForeground );
        XDrawImageString( XBGIDisplay, swin, XBGIDefaultGC, 
                         textstartx
                         + TextWidth( XBGIFontStruct, str, strlen(str) ),
                         textstarty, " ", 1 );
        if ( textstartx < 0 ){
          XSetForeground( XBGIDisplay, XBGIDefaultGC, XBGIBackground );
          XSetBackground( XBGIDisplay, XBGIDefaultGC, XBGIForeground );
          XDrawImageString( XBGIDisplay, swin, XBGIDefaultGC, 0, textstarty,
			   "<", 1 );
          XSetForeground( XBGIDisplay, XBGIDefaultGC, XBGIForeground );
          XSetBackground( XBGIDisplay, XBGIDefaultGC, XBGIBackground );
        }
      }else if ( ev.xexpose.window == owin ){
        xbgiDecorateWindow( XBGIDisplay, owin, XBGIDefaultGC,
                           XBGIForeground, XBGITopShadow, XBGIBottomShadow,
			   DecoRectFront );
        xbgiPrintf( XBGIDisplay, owin, XBGIDefaultGC, XBGIFontStruct,
		   CENTER_TEXT, OK );
      }else{
        xbgiDecorateWindow( XBGIDisplay, cwin, XBGIDefaultGC,
                           XBGIForeground, XBGITopShadow, XBGIBottomShadow,
			   DecoRectFront );
        xbgiPrintf( XBGIDisplay, cwin, XBGIDefaultGC, XBGIFontStruct,
		   CENTER_TEXT, CANCEL );
      }
      XFlush( XBGIDisplay );
      break;
    case KeyPress:
      if ( XLookupString( (XKeyEvent*)&ev, &c, 1, &key, NULL ) == 1 ){
        switch ( key ){
        case XK_Escape:
          strcpy( str, "" );
          flg = 0;
          break;
        case XK_Return:
          flg = 0;
          break;
        case XK_BackSpace:
        case XK_Delete:
          str[ max(0,strlen(str)-1) ] = '\0';
          break;
        case XK_Tab:
          break;
        case XK_space:
          break;
        default:
          if ( !IsCursorKey(key) && !IsFunctionKey(key) && !iscntrl(c) ){
            str[ min(strlen(str)+1,maxlen-1) ] = '\0';
            str[ min(strlen(str),  maxlen-2) ] = c;
          }else if ( iscntrl(c) ){
            switch(c){
            case CTRL('w'):
              strcpy( str, "" );
              break;
            }
          }
          break;
        }
      }
      XPutBackEvent( XBGIDisplay, &exposeev );
      break;
    case ButtonPress:
      switch ( ev.xbutton.button ){
      case Button1:
        if ( ev.xbutton.window == owin )
          flg = 0;
        else if ( ev.xbutton.window == cwin ){
          strcpy( str, "" );
          flg = 0;
        }
        break;
      case Button2:
        bytes = XFetchBytes( XBGIDisplay, &nbytes );
        bytes[nbytes] = '\0';
        if ( strlen(str)+nbytes < maxlen ){
          strcat( str, bytes );
        }
        XPutBackEvent( XBGIDisplay, &exposeev );
        break;
      }
    }
  }
  XUnmapSubwindows( XBGIDisplay, rwin );
  XUnmapWindow( XBGIDisplay, rwin );
}
void bgimenu( char *title, int menuc, char *menuv[], int *menui )
{
  Window rwin, twin, *mwin;
  XSetWindowAttributes att;
  XEvent ev, ahead;
  int i, width, height, textwidth, textheight, x, y;
  Window root, child;
  int rx, ry, wx, wy;
  unsigned int mask;
  
  xbgiGetSizePrintf( XBGIFontStruct, &textwidth, &textheight, "%s", title );
  for ( i=0; i<menuc; i++ ){
    xbgiGetSizePrintf( XBGIFontStruct, &width, &textheight, "%s", menuv[i] );
    if ( textwidth < width )
      textwidth = width;
  }
  width  = textwidth;
  height = textheight;
  x = XBGIEvent.xbutton.x_root;
  y = XBGIEvent.xbutton.y_root;
  x = x - Hem(width)/2;
  y = y - Hem(height)/2;
  rwin = XCreateSimpleWindow( XBGIDisplay, RootWindow(XBGIDisplay,XBGIScreen),
                             x, y,
                             Hem(Hem(width)), Hem(Hem(height)*(menuc+1)), 0,
                             XBGIForeground, XBGIBackground );
  XSelectInput( XBGIDisplay, rwin, ExposureMask );

  att.override_redirect = True;
  XChangeWindowAttributes( XBGIDisplay, rwin, CWOverrideRedirect, &att );
  twin = XCreateSimpleWindow( XBGIDisplay, rwin,
                             DecoHemBits, DecoHemBits,
                             Hem(width), Hem(height), 0,
                             XBGIForeground, XBGIBackground );
  mwin = (Window*)malloc( (menuc)*sizeof(Window) );
  for ( i=0; i<menuc; i++ ){
    mwin[i] = XCreateSimpleWindow( XBGIDisplay, rwin, 
                                  DecoHemBits, DecoHemBits+Hem(height)*(i+1),
                                  Hem(width), Hem(height), 0,
                                  XBGIForeground, XBGIBackground );
    XSelectInput( XBGIDisplay, mwin[i], ButtonMotionMask|
                 EnterWindowMask|LeaveWindowMask );
  }
  XPutBackEvent( XBGIDisplay, &XBGIEvent );
  while (1){
    XNextEvent( XBGIDisplay, &ev );
    switch ( ev.type ){
    case Expose:
      xbgiDecorateWindow( XBGIDisplay, rwin, XBGIDefaultGC,
                         XBGIForeground, XBGITopShadow, XBGIBottomShadow,
			 DecoRectFront );
      xbgiDecorateWindow( XBGIDisplay, twin, XBGIDefaultGC,
                         XBGIForeground, XBGITopShadow, XBGIBottomShadow,
			 DecoRectFront );
      xbgiPrintf( XBGIDisplay, twin, XBGIDefaultGC, XBGIFontStruct,
		 CENTER_TEXT,
                 "%s", title );
      for ( i=0; i<menuc; i++ ){
        xbgiDecorateWindow( XBGIDisplay, mwin[i], XBGIDefaultGC,
                           XBGIForeground, XBGITopShadow, XBGIBottomShadow,
			   DecoNothing );
        xbgiPrintf( XBGIDisplay, mwin[i], XBGIDefaultGC, XBGIFontStruct,
		   LEFT_TEXT, "%s", menuv[i] );
      }
      XFlush( XBGIDisplay );
      break;
    case EnterNotify:
      for ( i=0; i<menuc; i++ ){
        if ( ev.xcrossing.window == mwin[i] ){
          xbgiDecorateWindow( XBGIDisplay, mwin[i], XBGIDefaultGC, 
                             XBGIForeground, XBGITopShadow, XBGIBottomShadow,
			     DecoRectFront );
          xbgiPrintf( XBGIDisplay, mwin[i], XBGIDefaultGC, XBGIFontStruct,
		     LEFT_TEXT, "%s", menuv[i] );
          *menui = i;
        }
      }
      XFlush( XBGIDisplay );
      break;
    case LeaveNotify:
      *menui = -1;
      for ( i=0; i<menuc; i++ ){
        if ( ev.xcrossing.window == mwin[i] ){
          xbgiDecorateWindow( XBGIDisplay, mwin[i], XBGIDefaultGC,
                             XBGIForeground, XBGITopShadow, XBGIBottomShadow,
			     DecoNothing );
          xbgiPrintf( XBGIDisplay, mwin[i], XBGIDefaultGC, XBGIFontStruct,
		     LEFT_TEXT, "%s", menuv[i] );
        }
      }
      XFlush( XBGIDisplay );
      break;
#if 0
    case MotionNotify:
      while ( XEventsQueued( ev.xmotion.display, QueuedAfterReading  ) > 0 ){
        XPeekEvent( ev.xmotion.display, &ahead );
        if ( ahead.type != MotionNotify )
          break;
        if ( ahead.xmotion.window != ev.xmotion.window )
          break;
        XNextEvent( ev.xmotion.display, &ev );
      }
      XQueryPointer( XBGIDisplay, rwin, &root, &child,
                    &rx, &ry, &wx, &wy, &mask );
      if (( child == 0 )||( child == twin )){
        if ( *menui != -1 ){
          xbgiDecorateWindow( XBGIDisplay, mwin[*menui], XBGIDefaultGC,
                             XBGIForeground, XBGITopShadow, XBGIBottomShadow,
			     DecoNothing );
          xbgiPrintf( XBGIDisplay, mwin[*menui], XBGIDefaultGC,
		     XBGIFontStruct, LEFT_TEXT, "%s", menuv[*menui] );
        }
        *menui = -1;
      }else{
        for ( i=0; i<menuc; i++ )
          if ( child == mwin[i] ){
            if (( *menui != -1 )&&( *menui != i )){
              xbgiDecorateWindow( XBGIDisplay, mwin[*menui], XBGIDefaultGC,
                                 XBGIForeground, XBGITopShadow,
				 XBGIBottomShadow, DecoNothing );
              xbgiPrintf( XBGIDisplay, mwin[*menui], XBGIDefaultGC,
			 XBGIFontStruct, LEFT_TEXT, "%s", menuv[*menui] );
            }
            xbgiDecorateWindow( XBGIDisplay, mwin[i], XBGIDefaultGC,
                               XBGIForeground, XBGITopShadow,
			       XBGIBottomShadow, DecoRectFront );
            xbgiPrintf( XBGIDisplay, mwin[i], XBGIDefaultGC, XBGIFontStruct, 
                       LEFT_TEXT, "%s", menuv[i] );
            *menui = i;
            break;
          }
      }
      break;
#endif
    case ButtonPress:
      XMapWindow( XBGIDisplay, rwin );
      XMapSubwindows( XBGIDisplay, rwin );
      XFlush( XBGIDisplay );
      break;
    case ButtonRelease:
      XUnmapSubwindows( XBGIDisplay, rwin );
      XUnmapWindow( XBGIDisplay, rwin );
      XDestroySubwindows( XBGIDisplay, rwin );
      free( mwin );
      XDestroyWindow( XBGIDisplay, rwin );
      return;
      break;
    }
  }
}



