/*
 * Source File < x11/flood.c >
 *
 * Standard Functions: Borland Graphics Interface for Xlib
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#include "_bgi.h"

/*
 * standard function to fill flood
 */

#ifdef FLOODFILL_VERSION_SLOW

void floodfill( int x, int y, int border )
{
  int s[1000][2];
  int p, cx, cy, u, u2, d, d2, pu, pd;
  int minx, miny, maxx, maxy;
  int x, y, width, height;

  getgeometry( &x, &y, &width, &height );
  if ( XBGI->viewport.clip ){
    minx = XBGI->viewport.left;
    miny = XBGI->viewport.top;
    maxx = XBGI->viewport.right;
    maxy = XBGI->viewport.bottom;
  }else{
    minx = 0;
    miny = 0;
    maxx = width-1;
    maxy = height-1;
  }
  p = 1;
  s[p][0] = Xx(x);
  s[p][1] = Xy(y);
  while ( p > 0 ){
    cx = s[p][0];
    cy = s[p--][1];
    if ( getpixel( xX(cx), yX(cy) ) != border ){
      while ( getpixel( xX(cx), yX(cy) )!=border && cx>=minx ) cx--;
      cx++;
      u = 0;
      d = 0;
      while ( getpixel( xX(cx), yX(cy) )!=border && cx<=maxx ){
        putpixel( xX(cx), yX(cy), XBGI->fillset.color );
        u2 = u;
        if ( cy > miny ){
          pu = getpixel( xX(cx), yX(cy-1) );
          if ( pu == border || pu == XBGI->fillset.color )
            u = 0;
          else
            u = 1;
        }
        if ( u2==0 && u==1 ){
          p++;
          s[p][0] = cx;
          s[p][1] = cy - 1;
        }
        d2 = d;
        if ( cy < maxy ) {
          pd = getpixel( xX(cx), yX(cy+1) );
          if ( pd == border || pd == XBGI->fillset.color )
            d = 0;
          else
            d = 1;
        }
        if ( d2==0 && d==1 ){
          p++;
          s[p][0] = cx;
          s[p][1] = cy + 1;
        }
        cx++;
      }
    }
  }
}

#else /* FLOODFILL_VERSION_FAST */

#define pix(x,y) mem[height*(y)+(x)]
void floodfill( int x, int y, int border )
{
  int s[1000][2];
  int p, cx, cy, u, u2, d, d2, pu, pd;
  int minx, miny, maxx, maxy;
  int width, height, i, j, k;
  XImage *image;
  unsigned char *data, *mem;

  getgeometry( &cx, &cy, &width, &height );
  mem = (unsigned char*)malloc( width*height*sizeof(char) );
  if ( mem == NULL ){
    XBGI->gerror = grNoFloodMem;
    return;
  }
  image = XGetImage( XBGIDisplay, XBGIWins[XBGI->apage],
                    0, 0, width, height, AllPlanes, ZPixmap );
  data = (unsigned char *)image->data;
  for ( i=0; i<height; i++ ){
    for ( k=j=0; j<image->bytes_per_line; j++, data++ ){
      if ( j<image->xoffset ) continue;
      k++;
      if ( width < k ) continue;
      pix( k, i ) = XBGIColortable[*data];
    }
  }
  XDestroyImage( image );
  /* start scan filling */
  if ( XBGI->viewport.clip ){
    minx = XBGI->viewport.left;
    miny = XBGI->viewport.top;
    maxx = XBGI->viewport.right;
    maxy = XBGI->viewport.bottom;
  }else{
    minx = 0;
    miny = 0;
    maxx = width-1;
    maxy = height-1;
  }
  p = 1;
  s[p][0] = Xx(x);
  s[p][1] = Xy(y);
  while ( p > 0 ){
    cx = s[p][0];
    cy = s[p--][1];
    if ( pix( cx, cy ) != border ){
      while ( pix( cx, cy )!=border && cx>=minx ) cx--;
      cx++;
      u = 0;
      d = 0;
      while ( pix( cx, cy )!=border && cx<=maxx ){
        putpixel( xX(cx), yX(cy), XBGI->fillset.color );
        u2 = u;
        if ( cy > miny ){
          pu = pix( cx, cy-1 );
          if ( pu == border || pu == XBGI->fillset.color )
            u = 0;
          else
            u = 1;
        }
        if ( u2==0 && u==1 ){
          p++;
          s[p][0] = cx;
          s[p][1] = cy - 1;
        }
        d2 = d;
        if ( cy < maxy ) {
          pd = pix( cx, cy+1 );
          if ( pd == border || pd == XBGI->fillset.color )
            d = 0;
          else
            d = 1;
        }
        if ( d2==0 && d==1 ){
          p++;
          s[p][0] = cx;
          s[p][1] = cy + 1;
        }
        cx++;
      }
    }
  }
  free( mem );
}

#endif



