/*
 * Source File < x11/graphics.c >
 *
 * Standard Functions: Borland Graphics Interface for Xlib
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#include <stdio.h>
#include "graphix.h"

/*
  event.c: ----------------------- "event looper for simple event programing"
    xbgiloop(), set_event_handler()
  request.c: ------------------------------------------------ "request flush"
    xflush(), xsync()
  config.c: ------------------------- "configuration of graphics environment"
    getmaxx(), getmaxy(), setmaxx(), setmaxy(),
    getsizexy(), setsizexy(),
    getgeometry(), setgeometry(),
    settitle(), seticonname(), seticon(), setbackingstore(),
  driver.c: -------------------------------------- "graphics driver and mode"
    getdrivername(),
    getgraphmode(), setgraphmode(),
    getmodename(), getmaxmode(), getmoderange(),
    setgraphbufsize(),
    _graphfreemem(), _graphgetmem(),
    installuserdriver(),
    registerbgidriver(), registerfarbgidriver(),
    detectgraph(),
    _X11_driver(), X11_driver()
  init.c: ----------------------------- "initialize and close graphic system"
    _initgraph(), initgraph(),
    graphdefaults(),
    closegraph(),
  id.c: ------------------------------- "multi-graphic system using graph id"
    graphnumber(), selectgraph(), termgraph()
  util.c: ----------------------------------- "utilities for X-Window system"
    savegraphtoxbm(), savegraphtoxpm()
  error.c: ------------------------------------------------ "error messenger"
    graphresult(), grapherrormsg()
  page.c: ------------------------------------------ "page as drawing device"
    cleardevice(),
    setactivepage(), setvisualpage(),
    restorecrtmode()
  viewport.c: -------------------------- "viewport as virtual drawing device"
    clearviewport(),
    setviewport(), getviewport(),
  lineinfo.c: ----------------------------------------------- "line settings"
    setlinestyle()
    getlinesettings()
  writeops.c: ----------------------------------------- "set write operation"
    setwritemode()
  move.c: --------------------------------------------------- "current point"
    getx(), gety(), moveto(), moverel()
  line.c: ---------------------------------------------------- "drawing line"
    line(), lineto(), linerel()
  rect.c: ----------------------------------------------- "drawing rectangle"
    rectangle()
  poly.c: ------------------------------------------------- "drawing polygon"
    drawpoly()
  arcinfo.c: ------------------------------------------------- "arc settings"
    getarccoords()
    getaspectratio(), setaspectratio()
  arc.c: ------------------------------------------------------ "drawing arc"
    arc(), circle(), ellipse(),
  fillinfo.c: ----------------------------------------------- "fill settings"
    getfillsettings(), getfillpattern()
    setfillstyle(), setfillpattern()
  fillrect.c: ------------------------------------------- "filling rectangle"
    bar(), bar3d()
  fillpoly.c: --------------------------------------------- "filling polygon"
    fillpoly()
  fillarc.c: -------------------------------------------------- "filling arc"
    fillellipse(), pieslice(), sector()
  flood.c: -------------------------------------------------- "filling flood"
    floodfill()
  pixel.c: ---------------------------------------------------------- "pixel"
    getpixel(), putpixel()
  image.c: ---------------------------------------------------------- "image"
    imagesize(),
    getimage(), putimage()
  textinfo.c: ----------------------------------------------- "text settings"
    texthight(), textwidth(),
    gettextsettings()
    settextstyle(), settextjustify()
    setusercharsize(), installuserfont(),
    registerbgifont()
  text.c: -------------------------------------------- "out text on graphics"
    outtext(), outtextxy()
  color.c: ---------------------------------------------- "get and set color"
    getcolor(), getbkcolor(), getmaxcolor()
    setcolor(), setbkcolor(), setmaxcolor(),
  palette.c: ------------------------------- "get and set palette and colors"
    getdefaultpalette(), getpalette(), getpalettesize(),
    setallpalette(), setpalette(), setrgbpalette(), _setrgbpalette()
  ---------------------------------------------------------------------------
 */

/*
 * the header of XBGI to stack and it's initialized
 */
xbgi *XBGIS = NULL;

/*
 * the current XBGI and it's initialized
 */
xbgi *XBGI = NULL;

/*
 * the current XBGI driver and it's initialized
 */
void (*XBGI_CURRENT_DRIVER)( void ) = X11_driver;


