/*
 * Source File < x11/util.c >
 *
 * Standard Functions: Borland Graphics Interface for Xlib
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#include "_bgi.h"

/*
 * official enhanced function to save to x bitmap file
 */
int savegraphtoxbm( char *filename )
{
  Pixmap bitmap;
  GC gc;
  XImage *image;
  int i, j, k;
  int x, y, width, height;
  unsigned char *data;
  int status = !BitmapSuccess;

  if ( 0 <= XBGI->vpage && XBGI->vpage < XBGI->npage ){
    getgeometry( &x, &y, &width, &height );
    bitmap = XCreatePixmap( XBGIDisplay, XBGIWins[XBGI->vpage],
                           width, height, 1 );
    gc = XCreateGC( XBGIDisplay, bitmap, 0, 0 );
    XSetForeground( XBGIDisplay, gc, WhitePixel(XBGIDisplay,XBGIScreen) );
    XSetBackground( XBGIDisplay, gc, BlackPixel(XBGIDisplay,XBGIScreen) );
    XSetFillStyle( XBGIDisplay, gc, FillSolid );
    XFillRectangle( XBGIDisplay, bitmap, gc, 0, 0, width, height );
    XSetForeground( XBGIDisplay, gc, BlackPixel(XBGIDisplay,XBGIScreen) );
    XSetBackground( XBGIDisplay, gc, WhitePixel(XBGIDisplay,XBGIScreen) );
    image = XGetImage( XBGIDisplay, XBGIWins[XBGI->vpage],
                      0, 0, width, height, AllPlanes, ZPixmap );
    data = (unsigned char *)image->data;
    for ( i=0; i<height; i++ ){
      for ( k=j=0; j<image->bytes_per_line; j++, data++ ){
        if ( j<image->xoffset ) continue;
        k++;
        if ( width < k ) continue;
        if ( XBGIColortable[*data] != XBGI->bkcolor )
          XDrawPoint( XBGIDisplay, bitmap, gc, k, i );
      }
    }
    XDestroyImage( image );
    status = XWriteBitmapFile( XBGIDisplay, filename, bitmap,
                              width, height, 0, 0 );
    XFreeGC( XBGIDisplay, gc );
    XFreePixmap( XBGIDisplay, bitmap );
  }
  return status == BitmapSuccess;
}
/*
 * official enhanced function to save to x pixmap file
 */
int savegraphtoxpm( char *filename )
{
  XImage *image;
  int i, j, k;
  int x, y, width, height;
  int status = !BitmapSuccess;

#ifdef ENABLE_XPMLIB
  if ( 0 <= XBGI->vpage && XBGI->vpage < XBGI->npage ){
    getgeometry( &x, &y, &width, &height );
    image = XGetImage( XBGIDisplay, XBGIWins[XBGI->vpage],
                      0, 0, width, height, AllPlanes, ZPixmap );
    status = XpmWriteFileFromImage( XBGIDisplay, filename, image, 0, NULL );
    XDestroyImage( image );
  }
#else
  status = !BitmapSuccess;
#endif
  return status == BitmapSuccess;
}



